

{   Nintendo Gameboy Disassembler V1.3  }
{              by                       }
{         Jeff Frohwein                 }
{   Written in Turbo Pascal V6.0        }
{   Started: 25 Nov 93                  }
{   Last edited: 9 Jun 96               }

Uses Crt;

const
 buflen = 2048;

var
 f,c:file;
 fo:text;
 nct:char;
 obuf:array[0..32767] of byte; {input buffer}
 cbuf:array[0..buflen-1] of byte;  {control table}
 sbuf:array[0..3000] of word;  {symbol Table}
 addr_labels,columns,break,done,empty_line:boolean;
 hex_with_h,high_addr_labels,label_colon,label_off_once:boolean;
 line_written,low_addr_labels,ncf,one_data_element:boolean;
 symbol,tabs,trailer,variable:boolean;
 s:string;
 cdt,count,b1,b2,k,l,m,marker,ocdt,op,pair,pass:byte;
 cp,pc,fpc,lpc,nca,nla,npc,opc,sl,stp,z:word;
 in_count,NumRead:word;
 in_filename,out_filename,tab_filename:string;

procedure output(a:string);
 begin
  if pass=2 then
   write(fo,a);
 end;

procedure output_cr_lf;
 begin
  if pass=2 then
   begin
    output(chr(13));
    output(chr(10));
{    delay(100);      }
   end;
  end;

procedure add_regs(b:byte);
 var a:string;
 begin
  case (b and 7) of
   0:a:='b';
   1:a:='c';
   2:a:='d';
   3:a:='e';
   4:a:='h';
   5:a:='l';
   6:a:='(hl)';
  else
     a:='a';
  end;
     s:=concat(s,a);
 end;

procedure add_regp(b:byte);
 var a:string;
 begin
  case (b and 3) of
   0:a:='bc';
   1:a:='de';
   2:a:='hl';
  else
     a:='sp';
  end;
     s:=concat(s,a);
 end;

procedure add_cb(b:byte);
 var a:string;
 begin
  case (b and 7) of
   0:a:='nz';
   1:a:='z';
   2:a:='nc';
   3:a:='c';
   4:a:='po';
   5:a:='pe';
   6:a:='p';
  else
     a:='m';
  end;
     s:=concat(s,a);
 end;

procedure add_symbol(l:word);
 var
  p,y,z:word;
 begin
  if pass=1 then
   begin

    p:=0;
    while (p<>sl) and ( (l>z) or (p=0) ) do
     begin
      z:=sbuf[p];
      p:=p+1;
     end;

    if (sl=0) or (l>z) then  { (Empty table) or (End of table) }
     begin
      sbuf[p]:=l;  {Add symbol to table}
      sl:=sl+1;    {Increment Symbol Table Length}
     end
    else
     if l<>z then  {if symbol not already present, do this}
      begin
       y:=sl;
       repeat
        sbuf[y]:=sbuf[y-1];  {Move symbols down to make room}
        y:=y-1;
       until (y=p-1);
       sbuf[y]:=l; {Add symbol to table}
       sl:=sl+1;   {Increment Symbol Table Length}
      end;
   end;
 end;

function hex8(a:byte):string;
 var b,c:char;
 begin
   hex8[0]:=chr(2);
  if (a shr 4)<10 then
   hex8[1]:=chr((a shr 4)+48)
  else
   hex8[1]:=chr((a shr 4)+87);
  if (a and 15)<10 then
   hex8[2]:=chr((a and 15)+48)
  else
   hex8[2]:=chr((a and 15)+87);
 end;

function printable(a:byte):char;
 var b:byte;
 begin
  b:=a and 127;
  if (b>$1f) and (b<$7e) then
   printable:=chr(b)
  else
   printable:='.';
 end;

procedure add_string(a:string);
 begin
  s:=concat(s,a);
 end;

procedure add_comma;
 begin
  add_string(',');
 end;

procedure add_nlz8(b1:byte);
 begin
  if hex_with_h then
   begin

    if (b1>$9f) or not(variable) then
     add_string('0');

    if (b1>9) or not(variable) then
     begin
      if (b1 shr 4)<10 then
       add_string(chr((b1 shr 4)+48))
      else
       add_string(chr((b1 shr 4)+87));
     end;

    if (b1 and 15)<10 then
     add_string(chr((b1 and 15)+48))
    else
     add_string(chr((b1 and 15)+87));

    if (b1>9) or not(variable) then
     add_string('h');
   end
  else
   begin

    if (b1>9) or not(variable) then
     begin
      add_string('$');
      if (b1 shr 4)<10 then
       add_string(chr((b1 shr 4)+48))
      else
       add_string(chr((b1 shr 4)+87));
     end;

    if (b1 and 15)<10 then
     add_string(chr((b1 and 15)+48))
    else
     add_string(chr((b1 and 15)+87));
   end;
 end;

procedure add_raw16(w:word);
 begin

  if (w>$fff) or not(variable) or (hex_with_h and (w>$9ff)) then
   begin
    if (w shr 12)<10 then
     add_string(chr((w shr 12)+48))
    else
     add_string(chr((w shr 12)+87));
   end;

  if (w>$ff) or not(variable) or (hex_with_h and (w>$9f)) then
   begin
    if ((w shr 8) and 15)<10 then
     add_string(chr(((w shr 8) and 15)+48))
    else
     add_string(chr(((w shr 8) and 15)+87));
   end;


  if (w>$f) or not(variable) or (hex_with_h and (w>9)) then
   begin
    if ((w shr 4) and 15)<10 then
     add_string(chr(((w shr 4) and 15)+48))
    else
     add_string(chr(((w shr 4) and 15)+87));
   end;

  if (w and 15)<10 then
   add_string(chr((w and 15)+48))
  else
   add_string(chr((w and 15)+87));

 end;


procedure add_nlz16(w:word);
 begin
  if hex_with_h then
   begin

    if (w>$9fff) or not(variable) then
     add_string('0');

    add_raw16(w);

    if (w>9) or not (variable) then
     add_string('h');
   end
  else
   begin
    if (w>9) or not (variable) then
     add_string('$');
    add_raw16(w);
   end;
 end;

procedure add_badop;
 begin
  add_string('.db ');
  add_nlz8(op);
 end;

procedure add_immed8;
 begin
  add_nlz8(b1);
  npc:=npc+1;
 end;

procedure add_label8;
 begin
{  add_string('l');      }
{  add_string(hex8(b1)); }
{  npc:=npc+1;           }
  add_immed8;
 end;

procedure add_plabel8;
 begin
  add_string('(');
  add_label8;
  add_string(')');
 end;

procedure add_label16;
 var a:string;
 begin
   if ((b2<128) or (high_addr_labels)) and
      (addr_labels) and
      not(label_off_once) then
    begin
      add_string('l');
      add_string(hex8(b2));
      add_string(hex8(b1));
      add_symbol((b2 shl 8)+b1);
    end
   else
    begin
      add_nlz16((b2 shl 8)+b1);
      label_off_once:=false;
    end;
   npc:=npc+2;
 end;

procedure add_ilabel16;
 var a:string;
 begin
   if (b2=0) and (b1<256) and
      not(low_addr_labels) then
    begin
      add_nlz16((b2 shl 8)+b1);
      npc:=npc+2;
    end
   else
     add_label16;
 end;

procedure add_plabel16;
 begin
  add_string('(');
  add_label16;
  add_string(')');
 end;

procedure add_space;
 begin
  add_string(' ');
 end;

procedure add_trailer;
 var p,z:byte;
 begin
  p:=0;
  for z:=1 to length(s) do
   begin
    if s[z]=' ' then
     p:=p+8-(p and 7)
    else
     p:=p+1;
   end;
  if p<16 then add_string(' ');
  if p<24 then add_string(' ');

  add_string(' ; ');
  add_string(hex8(opc shr 8));
  add_string(hex8(opc and 255));
  for z:=1 to (npc-opc) do
   begin
    add_space;
    add_string(hex8(obuf[opc+z-1]));
   end;
  add_string('   ');
  for z:=1 to (npc-opc) do
   begin
    add_string(printable(obuf[opc+z-1]));
   end;
 end;

procedure output_line;
 var p,y,z:integer;
 begin
  if tabs then
   begin
    output(s);
    output_cr_lf;
   end
  else
   begin
    p:=0;
    for z:=1 to length(s) do
     begin
      if s[z]=chr(9) then
       begin
        for y:=1 to (8-(p and 7)) do
         output(' ');
        p:=0;
       end
      else
       begin
        output(s[z]);
        p:=p+1;
       end;
     end;
    output_cr_lf;
   end;
 end;

procedure insert_empty_line;
 begin
  if empty_line then
   begin
    output_cr_lf;
    empty_line:=false;
   end;
 end;

procedure insert_tabs;
 var z:integer;
 begin
  z:=0;
  repeat
   z:=z+1;
   if s[z]=chr(32)
    then s[z]:=chr(9);
  until (s[z]=';') or (z=length(s));
 end;

procedure inst_decode;
 var z:integer;
 begin
  op:=obuf[npc];
  b1:=obuf[npc+1];
  b2:=obuf[npc+2];
  npc:=npc+1;
  l:=op shr 6;
  m:=(op shr 3) and 7;
  k:=op and 7;

  case l of
   0:begin
     {op = 00XXXXXX}
      case k of
       0:begin
         {op = 00XXX000}
          case m of
           0:add_string('nop');
           1:begin
              add_string('ld ');
              add_plabel16;
              add_string(',sp');
             end;
           2:begin
              if b1=0 then
               add_string('stop')
              else
               begin
                add_string('.db 10h,');
                add_nlz8(b1);
               end;
              npc:=npc+1;
             end;
           3:begin
              add_string('jr ');
              empty_line:=true;
             end;
           4:add_string('jr nz,');
           5:add_string('jr z,');
           6:add_string('jr nc,');
          else
             add_string('jr c,');
          end;
          if m>2 then
           begin
            if b1<128 then
             z:=npc+b1+1
            else
             z:=npc-(255-b1);
            add_string('l');
            add_string(hex8(z shr 8));
            add_string(hex8(z and 255));
            npc:=npc+1;
            add_symbol(z);
           end;
         end;
       1:begin
         {op = 00XXX001}
          if (op and 8)=0 then
           begin
            add_string('ld ');
            add_regp(m shr 1);
            add_comma;
            add_ilabel16;
           end
          else
           begin
            add_string('add hl,');
            add_regp(m shr 1);
           end;
         end;
       2:begin
         {op = 00XXX010}
          case m of
           0:add_string('ld (bc),a');
           1:add_string('ld a,(bc)');
           2:add_string('ld (de),a');
           3:add_string('ld a,(de)');
           4:begin
              { add_string('ld '); }
              { add_plabel16;      }
              { add_string(',hl'); }
              add_string('ldi (hl),a');  {Gameboy Specific}
             end;
           5:begin
              { add_string('ld hl,'); }
              { add_plabel16;         }
              add_string('ldi a,(hl)');  {Gameboy Specific}
             end;
           6:begin
              { add_string('ld '); }
              { add_plabel16;      }
              { add_string(',a');  }
              add_string('ldd (hl),a');  {Gameboy Specific}
             end;
          else
             begin
              add_string('ldd a,(hl)');  {Gameboy Specific}
             end;
          end;
         end;
       3:begin
         {op = 00XXX011}
          if (m and 1)=0 then
           add_string('inc ')
          else
           add_string('dec ');
          add_regp(m shr 1);
         end;
       4:begin
         {op = 00XXX100}
          add_string('inc ');
          add_regs(m);
         end;
       5:begin
         {op = 00XXX101}
          add_string('dec ');
          add_regs(m);
         end;
       6:begin
         {op = 00XXX110}
          add_string('ld ');
          add_regs(m);
          add_comma;
          add_immed8;
         end;
      else
         begin
         {op = 00XXX111}
          case m of
           0:add_string('rlca');
           1:add_string('rrca');
           2:add_string('rla');
           3:add_string('rra');
           4:add_string('daa');
           5:add_string('cpl');
           6:add_string('scf');
          else
             add_string('ccf')
          end;
         end;
      end;
      end;
   1:begin
     {op = 01XXXXXX}
      if (m=6) and (k=6) then
       add_string('halt')
      else
       begin
        add_string('ld ');
        add_regs(m);
        add_comma;
        add_regs(k);
       end;
     end;
   2:begin
     {op = 10XXXXXX}
      case m of
       0:add_string('add a,');
       1:add_string('adc a,');
       2:add_string('sub ');
       3:add_string('sbc a,');
       4:add_string('and ');
       5:add_string('xor ');
       6:add_string('or ');
      else
         add_string('cp ');
      end;
      add_regs(k);
     end;
  else
  {op = 11XXXXXX}
   case k of
    0:begin
      {op = 11XXX000}
       if m=7 then
        begin
         add_string('ld hl,(sp');
         if b1<128 then
          begin
           add_string('+');
           add_nlz8(b1);
          end
         else
          begin
           add_string('-');
           add_nlz8(-b1);
          end;
         add_string(')');
         npc:=npc+1;
        end
       else
        if (m and 5)=4 then
         begin
          if (m and 2)=0 then
           begin
            add_string('ldh ');
            add_plabel8;
            add_string(',a');
           end
          else
           begin
            add_string('ldh a,');
            add_plabel8;
           end
         end
        else
         if m < 4 then
          begin
           add_string('ret ');
           add_cb(m);
          end
         else
          add_badop;
      end;
    1:begin
      {op = 11XXX001}
       case m of
        0:add_string('pop bc');
        1:begin
           add_string('ret');
           empty_line:=true;
          end;
        2:add_string('pop de');
        3:begin
           add_string('reti');
           empty_line:=true;
          end;
        4:add_string('pop hl');
        5:begin
           add_string('jp (hl)');
           empty_line:=true;
          end;
        6:add_string('pop af');
       else
          add_string('ld sp,hl');
       end;
      end;
    2:begin
      {op = 11XXX010}
       if (m and 5)=5 then
        begin
         if (m and 2)=0 then
          begin
           add_string('ld ');
           add_plabel16;
           add_string(',a');
          end
         else
          begin
           add_string('ld a,');
           add_plabel16;
          end
        end
       else
        if (m and 5)=4 then
         begin
          if m=6 then
           add_string('ldh a,(c)')
          else
           add_string('ldh (c),a');
         end
        else
         begin
          add_string('jp ');
          add_cb(m);
          add_comma;
          add_label16;
         end;
      end;
    3:begin
      {op = 11XXX011}
       case m of
        0:begin
           add_string('jp ');
           add_label16;
           empty_line:=true;
          end;
        1:begin
          {op = CB}
           l:=b1 shr 6;
           m:=(b1 shr 3) and 7;
           k:=b1 and 7;
           npc:=npc+1;
           case l of
            0:begin
               case m of
                0:add_string('rlc ');
                1:add_string('rrc ');
                2:add_string('rl ');
                3:add_string('rr ');
                4:add_string('sla ');
                5:add_string('sra ');
                6:add_string('swap ');
                7:add_string('srl ');
               end;
               add_regs(k);
              end;
            1:add_string('bit ');
            2:add_string('res ');
            3:add_string('set ');
           end;
           if l<>0 then
            begin
             add_string(chr(m+48));
             add_comma;
             add_regs(k);
            end;
          end;
        2:add_badop; {out}
        3:add_badop; {in}
        4:add_badop; {ex (sp),hl}
        5:add_badop; {ex de,hl}
        6:add_string('di');
       else
          add_string('ei');
       end;
      end;
    4:if m < 4 then
       begin
       {op = 11XXX100}
        add_string('call ');
        add_cb(m);
        add_comma;
        add_label16;
       end
      else
       add_badop;
    5:begin
      {op = 11XXX101}
       case m of
        0:add_string('push bc');
        1:begin
           add_string('call ');
           add_label16;
          end;
        2:add_string('push de');
        3:add_badop;
        4:add_string('push hl');
        5:add_badop;
        6:add_string('push af');
       else
          add_badop;
       end;
      end;
    6:begin
      {op = 11XXX110}
       case m of
        0:add_string('add a,');
        1:add_string('adc a,');
        2:add_string('sub ');
        3:add_string('sbc a,');
        4:add_string('and ');
        5:add_string('xor ');
        6:add_string('or ');
       else
          add_string('cp ');
       end;
       add_immed8;
      end;
   else
      begin
      {op = 11XXX111}
       add_string('rst ');
       add_nlz8(m shl 3);
     end;
   end;
  end;
 end;

function conv_hex_str(a:byte):byte;
 begin
  if a<$40 then
   conv_hex_str:=a-48
  else
   conv_hex_str:=a-87;
 end;

function chk_ctl:byte;
 begin
  if in_count=0 then
   begin
    BlockRead(c,cbuf,SizeOf(cbuf),NumRead);
    in_count:=buflen;
   end;
  chk_ctl:=cbuf[buflen-in_count] and $7f;
{  write('>',cbuf[buflen-in_count],'<');  }
 end;

function get_ctl:byte;
 begin
  get_ctl:=chk_ctl;
  dec(in_count);
 end;

procedure do_control_table;
 var a:byte;
 begin
  while ((npc=nca) or (npc>nca)) and not(done) do
   begin
    case nct of

     ';': begin                            {Insert comments into disassembly}
           if npc=nca then
            begin
             insert_empty_line;
             output(';');
            end;
           repeat
            a:=get_ctl;
            if npc=nca then output(chr(a));
           until (a=10) or (chk_ctl=26);
          end;

     'e': if npc=nca then output_cr_lf;
     'b': cdt:=1; {Set data type to Byte}
     'c': begin
           cdt:=0; {Set data type to Code}
           empty_line:=true;
          end;
     'w': cdt:=2; {Set data type to Word}
     'f': if ncf then columns:=true         {Enable/Disable Columns}
                     else
                      columns:=false;

     'h': if ncf then hex_with_h:=true      {Hex number format}
                     else
                      hex_with_h:=false;

     'k': if ncf then label_colon:=true {Enable/Disable label colon}
                     else
                      label_colon:=false;

     'l': if ncf then addr_labels:=true {Enable/Disable addr labels}
                     else
                      addr_labels:=false;

     'm': if ncf then high_addr_labels:=true {Enable/Disable high addr labels}
                     else
                      high_addr_labels:=false;

     'n': label_off_once:=true;       {Disable any label only in the next}

     'o': if ncf then one_data_element:=true {Enable/Disable one data element}
                     else
                      one_data_element:=false;

     't': if ncf then trailer:=true         {Enable/Disable Trailer Data}
                     else
                      trailer:=false;

     'v': if ncf then variable:=true         {Enable/Disable var len Data}
                     else
                      variable:=false;

     'x': if ncf then low_addr_labels:=true         {Enable/Disable var len Data}
                     else
                      low_addr_labels:=false;

     'z': done:=true;
    end;

    while (chk_ctl in [9,10,13,32]) do
     a:=get_ctl;

    if chk_ctl=ord(';') then    {Ignore comments in control file}
     repeat
      a:=get_ctl;
     until (a=10) or (chk_ctl=26);

    if not(chr(chk_ctl) in ['0'..'9','a'..'f']) then   {Collect addr from ctl file}
     nca:=$ffff
    else
     begin
      nca:=    conv_hex_str(get_ctl)*$1000;
      nca:=nca+conv_hex_str(get_ctl)*$100;
      nca:=nca+conv_hex_str(get_ctl)*$10;
      nca:=nca+conv_hex_str(get_ctl);

      while (chk_ctl in [9,32]) do
       a:=get_ctl;

      nct:=chr(get_ctl);        {Collect command from control file}

      if chk_ctl=ord('-') then
       ncf:=false
      else
       ncf:=true;
      if (chk_ctl=ord('+')) or (chk_ctl=ord('-')) then
       a:=get_ctl;
     end;
   end;
 end;

procedure data_bytes;
 begin
  op:=obuf[npc];
  npc:=npc+1;
  add_nlz8(op);
 end;

procedure data_words;
 begin
  b1:=obuf[npc];
  b2:=obuf[npc+1];
  add_ilabel16;
 end;

procedure add_symbol_string;
 begin
  s:=concat('l',hex8(nla shr 8));
  s:=concat(s,hex8(nla and 255));
  if label_colon then
   s:=concat(s,':');
 end;

function check_symbol_table:boolean;
 begin
  check_symbol_table:=false;
  if not((sl=0) or (stp=sl)) then    {sym table not empty or not at end}
   begin
    if npc>nla then
     begin
      repeat
       stp:=stp+1;
       nla:=sbuf[stp];
      until (stp=sl) or not(npc>nla);
     end;

    if npc=nla then check_symbol_table:=true;
   end;
 end;

procedure setup_flags;
 begin
  addr_labels:=true;
  columns:=true;
  hex_with_h:=true;
  high_addr_labels:=false;
  label_colon:=true;
  label_off_once:=false;
  low_addr_labels:=false;
  one_data_element:=false;
  trailer:=true;
  variable:=true;
 end;

function Control_Ready:boolean;
 begin
  if ((npc=nca) or (npc>nca)) and not(done) then
   Control_Ready:=true
  else
   Control_Ready:=false;
 end;

function Control_Newline:boolean;
 begin
  if nct in [';','c','e','o','z'] then
   Control_Newline:=true
  else
   Control_Newline:=false;
 end;

procedure write_line;
 begin
  if trailer then add_trailer;
  if columns then insert_tabs;
  output_line;
  insert_empty_line;
 end;

procedure rotate;
 begin
  if npc>(marker*1024) then
   begin
    marker:=marker+1;
    case (marker and 7) of
     0,4: write(#8'\');
     1,5: write(#8'|');
     2,6: write(#8'/');
     3,7: write(#8'-');
    end;
   end;
 end;

begin
 tabs:=false;
 empty_line:=false;
 break:=false;
 sl:=0;
 stp:=0;

 writeln('GameBoy Disassembler (GBDis) V1.3 by Jeff Frohwein, 1993-1996');
 writeln;

 in_filename:=ParamStr(1);
 if pos('.',in_filename)=0 then
  in_filename:=concat(in_filename,'.gb');

 tab_filename:=copy(in_filename,1,pos('.',in_filename)-1);

 If ParamCount>1 then
  out_filename:=ParamStr(2)
 else
  out_filename:=concat(tab_filename,'.asm');

 tab_filename:=concat(tab_filename,'.tab');

 Assign(f,in_filename);
 {$I-}
 Reset(f);
 {$I+}
 If IOResult=0 then
  begin
   BlockRead(f,obuf,32767,NumRead);
   Close(f);
  end
 else
  begin
   writeln('File "',in_filename,'" not found.');
   break:=true;
  end;

 Assign(c,tab_filename);
 {$I-}
 Reset(c);
 {$I+}
 If IOResult=0 then
  begin
   Close(c);
  end
 else
  begin
   writeln('File "',tab_filename,'" not found.');
   break:=true;
  end;

  if break then
   begin
    writeln('Usage:');
    writeln(' gbdis in_file[.gb] [out_file]');
    writeln;
   end;

{ writeln('Generate Symbol Table? (Y/N)');     }
{ repeat                                       }
{  key:=readkey;                               }
{ until key in ['N','n','Y','y'];              }

{ if (key='y') or (key='Y') then symbol:=true  }
{                               else           }
{                                symbol:=false;}

 symbol:=true;

 fpc:=$0;
 lpc:=$7fff;

 setup_flags;
 cp:=0;
 npc:=fpc;
 nca:=fpc;
 nct:='c';
 stp:=0;
 cdt:=0;
 done:=false;

 count:=0;

 {Generate Symbol Table}

 pass:=1;
 marker:=0;

 if (symbol) and not(break) then
  begin
   Reset(c,1);
   in_count:=0;

   write('Pass 1 - Generating Label table -');
   repeat
    s:=' ';
    do_control_table;

    case cdt of
     0:inst_decode;
     1:data_bytes;
     2:data_words;
    end;

    rotate;

   until (npc>lpc) or (done);

   close(c);
   writeln(#8' ');
  end;

 setup_flags;
 cp:=0;
 opc:=fpc;
 nca:=fpc;
 nct:='c';
 cdt:=0;
 nla:=sbuf[0];
 done:=false;

 {Generate Output Disassembly}

 pass:=2;
 marker:=0;

 if not(break) then
  begin
   Reset(c,1);
   in_count:=0;

   if symbol then write('Pass 2 - ');

   write('Writing Output Disassembly to "',out_filename,'" -');

   Assign(fo,out_filename);
   Rewrite(fo);

   repeat
    s:='';
    npc:=opc;

    While (Control_Ready) do
     Do_Control_table;
    ocdt:=cdt;

    if Check_Symbol_table then
     add_symbol_string;

    if not(done) then
     begin
      s:=concat(s,' ');

      line_written:=false;
      case cdt of
       0:begin
          insert_empty_line;
          inst_decode;
         end;
       1:begin
          add_string('.db ');
          data_bytes;
         end;
       2:begin
          add_string('.dw ');
          data_words;
         end;
      end;
     end;

    while not(one_data_element) and
          not(line_written) and
          not(npc>lpc) and
          not(done) and
          (ocdt<>0) and
          (cdt=ocdt) and
          not(Check_Symbol_Table) and
          (length(s)<60) do
     begin

      while (Control_Ready) do
       begin
        if (Control_Newline) and
           not(line_written) then
         begin
          write_line;
          line_written:=true;
         end;
        Do_Control_Table;
       end;

      if not(line_written) and
         (cdt=ocdt) then
       begin
        case cdt of
         1:begin
            add_comma;
            data_bytes;
           end;
         2:begin
            add_comma;
            data_words;
           end;
        end;
       end;

     end;

    if not(line_written) then
     write_line;

    opc:=npc;

    rotate;

   until (npc>lpc) or (done);

   writeln(#8' ');

   s:=' .end';
   output_line;

   close(fo);
   close(c);
  end;

 if break then
  writeln('Program halted.');

 writeln('** Labels = ',sl,' **');

end.
